Loxone Binding

Hello everybody,

I made a Loxone Binding for HomeAssistant. It is in very early stage.
Here is the link to the git repository:

If you have a Loxone give it a try. Supported features are digital/analog sensors, switches, and jalousie.

Joachim

Hi Joachim,
I’m using your binding and it works great !
For the next steps, it would be cool to get Alarm controller support.
I have a few new module extensions to install in the coming days but after I could help.
I started writing the WS part a few months ago and stopped but you were faster :smile:

Great work, thank you.

Hi Simon,

thank you for your message. It is good to hear that my binding is useful for you.
It would be great if we can get it in the main branch from home assistant. I already
tried it but I struggled with the git requirements. Maybe I try it again when I have more
time.

Maybe I can look for the alarm controller suppoert. I let you know.

Thanks again for your message.

Joachim

It’s useful to me too so I would be very interested if you persevered with the integration into HA. I know it’s been a fraught experience.

Very interested in this but not sure how to install it into hassio. I have a Loxone system and I’m looking to integrate the two systems.

Can your code be used in hassio? if so can you give me a idea on how to install it please, thank you

Of course it is no problem. I use it in hassio. You need direct access to your configuration folder. For this you need to install the samba addon. If you have access to this folder download all files from my github repo. Copy the folder “custom_components” in this folder. Then include the example code from my github page and restart your home assistant instance.

If you still have problems search for custom components in Home Assistant.

Hope this helps.

Jojo

Thank you Jojo, got mine working on port 80, great.

Thank Jojo,
Your code snippet is extraordinary!
I have integrated Miniserver with HA.
However there is a small problem:
HA discover the rollers and light is directly linked to the switch button controls, but is not found for other light controlled via “LightControllerV2” component

Can you add that kind of control?
Best rgd!

Hoangtridung

I can look if I can add it. I have no lights. First I have to decode a different message typ (typ 3).
But I will check if I can integrate it.

Jojo

I try to copy those files in hassio 0.88.0 in “custom_components” but nothing happen … after restart HA error message >>>

Error during setup of component loxone
Traceback (most recent call last):
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 600, in urlopen
chunked=chunked)
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 384, in _make_request
six.raise_from(e, None)
File “”, line 2, in raise_from
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 380, in _make_request
httplib_response = conn.getresponse()
File “/usr/local/lib/python3.7/http/client.py”, line 1321, in getresponse
response.begin()
File “/usr/local/lib/python3.7/http/client.py”, line 296, in begin
version, status, reason = self._read_status()
File “/usr/local/lib/python3.7/http/client.py”, line 265, in _read_status
raise RemoteDisconnected(“Remote end closed connection without”
http.client.RemoteDisconnected: Remote end closed connection without response

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “/usr/local/lib/python3.7/site-packages/requests/adapters.py”, line 449, in send
timeout=timeout
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 638, in urlopen
_stacktrace=sys.exc_info()[2])
File “/usr/local/lib/python3.7/site-packages/urllib3/util/retry.py”, line 367, in increment
raise six.reraise(type(error), error, _stacktrace)
File “/usr/local/lib/python3.7/site-packages/urllib3/packages/six.py”, line 685, in reraise
raise value.with_traceback(tb)
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 600, in urlopen
chunked=chunked)
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 384, in _make_request
six.raise_from(e, None)
File “”, line 2, in raise_from
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 380, in _make_request
httplib_response = conn.getresponse()
File “/usr/local/lib/python3.7/http/client.py”, line 1321, in getresponse
response.begin()
File “/usr/local/lib/python3.7/http/client.py”, line 296, in begin
version, status, reason = self._read_status()
File “/usr/local/lib/python3.7/http/client.py”, line 265, in _read_status
raise RemoteDisconnected(“Remote end closed connection without”
urllib3.exceptions.ProtocolError: (‘Connection aborted.’, RemoteDisconnected(‘Remote end closed connection without response’))

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “/usr/local/lib/python3.7/site-packages/homeassistant/setup.py”, line 151, in _async_setup_component
hass, processed_config)
File “/config/custom_components/loxone.py”, line 129, in async_setup
request_code = lox_config.getJson()
File “/config/custom_components/loxone.py”, line 104, in getJson
verify=False)
File “/usr/local/lib/python3.7/site-packages/requests/api.py”, line 75, in get
return request(‘get’, url, params=params, **kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/api.py”, line 60, in request
return session.request(method=method, url=url, **kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/sessions.py”, line 533, in request
resp = self.send(prep, **send_kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/sessions.py”, line 646, in send
r = adapter.send(request, **kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/adapters.py”, line 498, in send
raise ConnectionError(err, request=request)
requests.exceptions.ConnectionError: (‘Connection aborted.’, RemoteDisconnected(‘Remote end closed connection without response’))

Do you still have this problem? Did you specify your host, port, username and password for the loxone component?

problem no fix yet …
the Host , port , User & password … should be ok , I can use the same setting connected to openhab …

My newest version which I uploaded a view days ago is only working for the newest home assistant version. Can you upgrade both. My component and your hassio?

Try to download the newest version … but same

Fri Mar 08 2019 03:53:59 GMT+0800 (HKT)

Error during setup of component loxone
Traceback (most recent call last):
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 600, in urlopen
chunked=chunked)
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 384, in _make_request
six.raise_from(e, None)
File “”, line 2, in raise_from
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 380, in _make_request
httplib_response = conn.getresponse()
File “/usr/local/lib/python3.7/http/client.py”, line 1321, in getresponse
response.begin()
File “/usr/local/lib/python3.7/http/client.py”, line 296, in begin
version, status, reason = self._read_status()
File “/usr/local/lib/python3.7/http/client.py”, line 265, in _read_status
raise RemoteDisconnected(“Remote end closed connection without”
http.client.RemoteDisconnected: Remote end closed connection without response

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “/usr/local/lib/python3.7/site-packages/requests/adapters.py”, line 449, in send
timeout=timeout
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 638, in urlopen
_stacktrace=sys.exc_info()[2])
File “/usr/local/lib/python3.7/site-packages/urllib3/util/retry.py”, line 367, in increment
raise six.reraise(type(error), error, _stacktrace)
File “/usr/local/lib/python3.7/site-packages/urllib3/packages/six.py”, line 685, in reraise
raise value.with_traceback(tb)
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 600, in urlopen
chunked=chunked)
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 384, in _make_request
six.raise_from(e, None)
File “”, line 2, in raise_from
File “/usr/local/lib/python3.7/site-packages/urllib3/connectionpool.py”, line 380, in _make_request
httplib_response = conn.getresponse()
File “/usr/local/lib/python3.7/http/client.py”, line 1321, in getresponse
response.begin()
File “/usr/local/lib/python3.7/http/client.py”, line 296, in begin
version, status, reason = self._read_status()
File “/usr/local/lib/python3.7/http/client.py”, line 265, in _read_status
raise RemoteDisconnected(“Remote end closed connection without”
urllib3.exceptions.ProtocolError: (‘Connection aborted.’, RemoteDisconnected(‘Remote end closed connection without response’))

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “/usr/local/lib/python3.7/site-packages/homeassistant/setup.py”, line 151, in _async_setup_component
hass, processed_config)
File “/config/custom_components/loxone/init.py”, line 129, in async_setup
request_code = lox_config.getJson()
File “/config/custom_components/loxone/init.py”, line 104, in getJson
verify=False)
File “/usr/local/lib/python3.7/site-packages/requests/api.py”, line 75, in get
return request(‘get’, url, params=params, **kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/api.py”, line 60, in request
return session.request(method=method, url=url, **kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/sessions.py”, line 533, in request
resp = self.send(prep, **send_kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/sessions.py”, line 646, in send
r = adapter.send(request, **kwargs)
File “/usr/local/lib/python3.7/site-packages/requests/adapters.py”, line 498, in send
raise ConnectionError(err, request=request)
requests.exceptions.ConnectionError: (‘Connection aborted.’, RemoteDisconnected(‘Remote end closed connection without response’))

Can you turn on the log for the loxone component and paste it?

My log settings in the configuration.yaml are

logger:
default: critical
logs:
homeassistant.core: critical
custom_components.loxone: debug

I can not reproduce this error. Maybe we can find it out with the addional log messages.

Oh another question is what software version of the Loxone do you have? Loxone changed the
authentication and I support only the newest version. Openhab supports all three versions. Maybe this is the problem?

This is from the Loxone Config Dev Guide:

As of Loxone Config 9.3 password based authentication has been removed in
favor of token based authentication. Token based authentication has been
introduced in Loxone Config 9.0.

So for my component you need Loxone Config 9 or higher.

The binding has stopped working with a error:

python-jose-cryptodome 1.3.2 has requirement pycryptodome<3.4.0,>=3.3.1, but you'll have pycryptodome 3.8.0 which is incompatible.
pyrebase4 4.3.0 has requirement oauth2client==4.1.2, but you'll have oauth2client 4.0.0 which is incompatible.
broadlink 0.9 has requirement pycryptodome==3.4.11, but you'll have pycryptodome 3.8.0 which is incompatible.
Command "/usr/local/bin/python3 -u -c "import setuptools, tokenize;__file__='/tmp/pip-install-711zk5hp/pycryptodome/setup.py';f=getattr(tokenize, 'open', open)(__file__);code=f.read().replace('\r\n', '\n');f.close();exec(compile(code, __file__, 'exec'))" install --record /tmp/pip-record-xbqiat1g/install-record.txt --single-version-externally-managed --prefix  --compile --user --prefix=" failed with error code 1 in /tmp/pip-install-711zk5hp/pycryptodome/
You are using pip version 19.0.2, however version 19.0.3 is available.
You should consider upgrading via the 'pip install --upgrade pip' command.```

I can't work out how to upgrade pip in hassio

Any ideas please.

I found the mistake. Hassio changed some requirements. Please fetch my newest source code and
copy it in the custom compontens folder. Then it should work. That is the biggest problem when the code is not in the offical repo. I get no messages when they change something.

Thank you Jojo, problem solved with the new source code.

In answer to your first edit, I had just installed influxdb addon when I noticed the loxone binding had failed. I had made a backup before installing influx but reverting back to that snapshot didn’t solve the issue. Thanks again for your time.

I noticed today that I have a error in the dev-info:

Also when I go to the ‘states’ webpage, I have a Loxone Group title/view with nothing on the page.

But all is working, any ideas?